module SedgeCms
  require 'htmlbeautifier'
  require 'find'
  class SedgeApi::LocalesController < ActionController::Base
    def index
      locale = 'en'
      @mustache_file_paths = []
      @summernotes = {}
      Find.find(Rails.root.join('app', 'sedge')) do |path|
        @mustache_file_paths << path if path =~ /.*\.mustache$/
      end
      @mustache_file_paths.each do |path|
        f = File.read(path)
        doc = Nokogiri::HTML(PageAPI.render(f))
        summernotes = doc.css('summernote')
        summernotes.each do |sn|
          sedge_path = Rails.root.join('app', 'sedge')
          locale_path = Rails.root.join('app', 'sedge', 'locale')

          locale_base_path = File.dirname(path.gsub(sedge_path.to_s, ''))
          full_locale_path = "#{locale_path}/#{I18n.locale}#{locale_base_path}"
          full_locale_file_path = "#{full_locale_path}/#{File.basename(path, '.*')}/#{sn['file']}.mustache"


          # summernote_path = "#{File.dirname(path)}/#{File.basename(path, '.*')}/#{sn['file']}.mustache"
          @summernotes[full_locale_file_path.unpack('h*')[0]] = File.read(full_locale_file_path)
        end
      end
      render :json => @summernotes.to_json
    end
    def update
      summernotes_params.each do |k,html|
        # convert back to full path string
        path = [k].pack('h*')
        File.open(path,"w") do |f|
          f.write( HtmlBeautifier.beautify(html))
        end
      end

      g = Git.open(Rails.root, :log => Logger.new(STDOUT))
      g.add(:all=>true)
      commit = g.commit('updated by cms')

      render :json => ""
    end

  private

    def summernotes_params
      params.require(:summernote).permit!
    end

  end

end
